#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stack.h"

int eval_with_stack(char *exp[], int n, struct stack *s) {
    // Esta função funciona independente da implementação da pilha
    for (int i = 0; i < n; i++) {
        if (strcmp(exp[i], "*") == 0) {
            int r = pop(s) * pop(s);
            push(s, r);
        } else if (strcmp(exp[i], "+") == 0) {
            int r = pop(s) + pop(s);
            push(s, r);
        } else {
            push(s, atoi(exp[i]));
        }
    }
    int r = pop(s);
    return r;
}

int eval(char *exp[], int n) {
    // Escolhe dinamicamente uma implementação para pilha
    struct stack s;
    if (n < 10) {
        printf("Usando pilha com tamanho fixo\n");
        s = new_fixed_stack();
    } else {
        printf("Usando pilha com tamanho variável\n");
        s = new_dynamic_stack();
    }
    int r = eval_with_stack(exp, n, &s);
    destroy(&s);
    return r;
}

void test_case(char *exp[], int n, int expected) {
    printf("testando");
    for (int i = 0; i < n; i++) {
        printf(" %s", exp[i]);
    }
    printf(" == %d\n", expected);
    assert(eval(exp, n) == expected);
}

void test() {
    test_case((char *[]){"3", "4", "+"}, 3, 7);
    test_case((char *[]){"2", "4", "*"}, 3, 8);
    test_case((char *[]){"2", "4", "+", "3", "*"}, 5, 18);
    test_case((char *[]){"1", "2", "3", "4", "5", "6", "+", "+", "*", "*", "+"}, 11, 91);
}

int main(int argc, char *argv[]) {
    if (argc == 1) {
        test();
    } else {
        printf("%d\n", eval(argv, argc));
    }
}
