#include "stack.h"
#include "dynamic_stack.h"
#include "fixed_stack.h"

// stack

struct stack_methods fixed_stack_methods = {
    .push = (void (*)(void*, int))fixed_stack_push,
    .pop = (int (*)(void*))fixed_stack_pop,
    .destroy = (void (*)(void*))fixed_stack_destroy,
};

struct stack_methods dynamic_stack_methods = {
    .push = (void (*)(void*, int))dynamic_stack_push,
    .pop = (int (*)(void*))dynamic_stack_pop,
    .destroy = (void (*)(void*))dynamic_stack_destroy,
};

struct stack new_fixed_stack()
{
    return (struct stack) {
        .obj = fixed_stack_init(),
        .methods = &fixed_stack_methods,
    };
}

struct stack new_dynamic_stack()
{
    return (struct stack) {
        .obj = dynamic_stack_init(),
        .methods = &dynamic_stack_methods,
    };
}

void push(struct stack* s, int value)
{
    s->methods->push(s->obj, value);
}

int pop(struct stack* s)
{
    return s->methods->pop(s->obj);
}

void destroy(struct stack* s)
{
    s->methods->destroy(s->obj);
}
