#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stack.h"

int eval(char *exp[], int n) {
    struct stack *s = init();
    for (int i = 0; i < n; i++) {
        if (strcmp(exp[i], "*") == 0) {
            int r = pop(s) * pop(s);
            push(s, r);
        } else if (strcmp(exp[i], "+") == 0) {
            int r = pop(s) + pop(s);
            push(s, r);
        } else {
            push(s, atoi(exp[i]));
        }
    }
    int r = pop(s);
    destroy(s);
    return r;
}

void test_case(char *exp[], int n, int expected) {
    printf("testando");
    for (int i = 0; i < n; i++) {
        printf(" %s", exp[i]);
    }
    printf(" == %d\n", expected);
    assert(eval(exp, n) == expected);
}

void test() {
    test_case((char *[]){"3", "4", "+"}, 3, 7);
    test_case((char *[]){"2", "4", "*"}, 3, 8);
    test_case((char *[]){"2", "4", "+", "3", "*"}, 5, 18);
}

int main(int argc, char *argv[]) {
    if (argc == 1) {
        test();
    } else {
        printf("%d\n", eval(argv, argc));
    }
}
