#![allow(non_camel_case_types)]

pub type c_int = i32;

pub struct stack {
    vec: Vec<c_int>,
}

#[no_mangle]
pub extern "C" fn init() -> *mut stack {
    Box::into_raw(Box::new(stack { vec: vec![] }))
}

#[no_mangle]
pub extern "C" fn destroy(s: *mut stack) {
    unsafe {
        Box::from_raw(s);
    }
}

#[no_mangle]
pub extern "C" fn pop(s: *mut stack) -> c_int {
    unsafe {
        (&mut *s).vec.pop().unwrap()
    }
}

#[no_mangle]
pub extern "C" fn push(s: *mut stack, value: c_int) {
    unsafe {
        (&mut *s).vec.push(value);
    }
}
